//+------------------------------------------------------------------+
//|                                                        2MACD.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Szilard Kovacs"
#property link      "kovszilard*gmail*com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

extern string FastMACDSettings = "Fast MACD Settings";
extern int fFastEMA   = 5;
extern int fSlowEMA   = 10;
extern int fSignalSMA = 2;
extern string SlowMACDSettings = "Slow MACD Settings";
extern int sFastEMA   = 10;
extern int sSlowEMA   = 20;
extern int sSignalSMA = 5;
extern bool Alerts   = true;


datetime lastbar;
double   distance;

int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,225);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,226);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
//----
   
   distance = 0.3;
   if(StringFind(Symbol(), "JPY") == -1) distance = 0.003;
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   double fMacdMain, fMacdSignal, sMacdMain, sMacdSignal, fMacdMain2, fMacdSignal2, sMacdMain2, sMacdSignal2;
   

//----
   for(int i=Bars-counted_bars-1; i>=0; i--)
   {
      fMacdMain = iMACD(NULL, 0, fFastEMA, fSlowEMA, fSignalSMA, PRICE_CLOSE, MODE_MAIN, i);
      fMacdSignal = iMACD(NULL, 0, fFastEMA, fSlowEMA, fSignalSMA, PRICE_CLOSE, MODE_SIGNAL, i);
      sMacdMain = iMACD(NULL, 0, sFastEMA, sSlowEMA, sSignalSMA, PRICE_CLOSE, MODE_MAIN, i);
      sMacdSignal = iMACD(NULL, 0, sFastEMA, sSlowEMA, sSignalSMA, PRICE_CLOSE, MODE_SIGNAL, i);

      fMacdMain2 = iMACD(NULL, 0, fFastEMA, fSlowEMA, fSignalSMA, PRICE_CLOSE, MODE_MAIN, i+1);
      fMacdSignal2 = iMACD(NULL, 0, fFastEMA, fSlowEMA, fSignalSMA, PRICE_CLOSE, MODE_SIGNAL, i+1);
      sMacdMain2 = iMACD(NULL, 0, sFastEMA, sSlowEMA, sSignalSMA, PRICE_CLOSE, MODE_MAIN, i+1);
      sMacdSignal2 = iMACD(NULL, 0, sFastEMA, sSlowEMA, sSignalSMA, PRICE_CLOSE, MODE_SIGNAL, i+1);
      
      bool FastUpGreen = false;
      bool SlowUpGreen = false;
      bool FastDownRed = false;
      bool SlowDownRed = false;

      bool FastUpGreen2 = false;
      bool SlowUpGreen2 = false;
      bool FastDownRed2 = false;
      bool SlowDownRed2 = false;
      
      
      if(fMacdMain > 0 && fMacdSignal > 0 && fMacdMain > fMacdSignal) FastUpGreen = true;
      if(sMacdMain > 0 && sMacdSignal > 0 && sMacdMain > sMacdSignal) SlowUpGreen = true;
      if(fMacdMain < 0 && fMacdSignal < 0 && fMacdMain < fMacdSignal) FastDownRed = true;
      if(sMacdMain < 0 && sMacdSignal < 0 && sMacdMain < sMacdSignal) SlowDownRed = true;
      
      if(fMacdMain2 > 0 && fMacdSignal2 > 0 && fMacdMain2 > fMacdSignal2) FastUpGreen2 = true;
      if(sMacdMain2 > 0 && sMacdSignal2 > 0 && sMacdMain2 > sMacdSignal2) SlowUpGreen2 = true;
      if(fMacdMain2 < 0 && fMacdSignal2 < 0 && fMacdMain2 < fMacdSignal2) FastDownRed2 = true;
      if(sMacdMain2 < 0 && sMacdSignal2 < 0 && sMacdMain2 < sMacdSignal2) SlowDownRed2 = true;

      
      //LONG
      if(FastUpGreen && SlowUpGreen && (!FastUpGreen2 || !SlowUpGreen2))
      {
         ExtMapBuffer1[i] = Open[i] - distance;
      }
      
      //SHORT
      if(FastDownRed && SlowDownRed && (!FastDownRed2 || !SlowDownRed2))
      {
         ExtMapBuffer2[i] = Open[i] + distance;
      }

      if(Alerts && lastbar != Time[0])
      {
         if(ExtMapBuffer1[1] > 0) Alert("LONG: " + Symbol());
         if(ExtMapBuffer2[1] > 0) Alert("SHORT: " + Symbol());
         lastbar = Time[0];
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+